/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	教材構造ノードインタフェース
//			変更履歴
//				2004.01.08	新規作成	二條智文
//
package jp.co.ntt.lms.lo;

/**
 * 教材構造ノードインタフェースです。<BR>
 * @author T.Nijou
 * @version 0.0.0.1 2004/01/08
 */
public interface MaterialNode extends java.io.Serializable {

	/**
	 * コースノードをあらわします
	 */
	public static final int COURSE_NODE = 1;

	/**
	 * ブロックノードをあらわします
	 */
	public static final int BLOCK_NODE = 2;

	/**
	 * AUノードをあらわします
	 */
	public static final int AU_NODE = 3;

	/**
	 * 親ノードを取得します
	 * @return MaterialNode 親ノード
	 */
	public MaterialNode getParentNode();

	/**
	 * 親ノードを設定します
	 * @param objParentNode 親ノード
	 */
	public void setParentNode( MaterialNode objParentNode );

	/**
	 * 子ノードリストを取得します
	 * @return MaterialNodeList 子ノードリスト
	 */
	public MaterialNodeList getChildList();

	/**
	 * 子ノードを追加します
	 * @param objChildNode 子ノード
	 */
	public void addChild( MaterialNode objChildNode );

	/**
	 * パスを取得します
	 * @return String パス
	 */
	public String getPath();

	/**
	 * パスを設定します
	 * @param strPath パス
	 */
	public void setPath( String strPath );

	/**
	 * 教材IDを取得します
	 * @return String 教材ID
	 */
	public String getMaterialID();

	/**
	 * 教材IDを設定します
	 * @param strMaterialID 教材ID
	 */
	public void setMaterialID( String strMaterialID );

	/**
	 * 章IDを取得します
	 * @return String 章ID
	 */
	public String getAuID();

	/**
	 * 章IDを設定します
	 * @param strAuID 章ID
	 */
	public void setAuID( String strAuID );

	/**
	 * タイトルを取得します
	 * @return String タイトル
	 */
	public String getTitle();

	/**
	 * タイトルを設定します
	 * @param strTitle タイトル
	 */
	public void setTitle( String strTitle );

	/**
	 * ノードタイプを取得します
	 * @return int ノードタイプ
	 */
	public int getNodeType();

	/**
	 * ノードタイプを設定します
	 * @param intNodeType ノードタイプ
	 */
	public void setNodeType( int intNodeType );

	/**
	 * パスを指定して、子ノードリストからノードを検索します
	 * @param strPath パス
	 * @return MaterialNode 検索結果 見つからない場合はnull
	 */
	public MaterialNode searchChild( String strPath );

	/**
	 * IDを指定して、子ノードリストからノードを検索します
	 * @param strAuID AuID
	 * @return MaterialNode 検索結果 見つからない場合はnull
	 */
	public MaterialNode searchAUID( String strAuID );

}

